/*    
	th_dnh_archiver - A compresser/decompresser for Danmakufu's compression format
	Copyright (C) 2010 Legend_Bird

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

public class Main { 
	public static void main(String[] args) {
		start();
		if(args.length<=2) help();
		else {
			boolean override = false, extract = false, create = false, pack = false, verbose = false/*, batch = false*/;
			int i=0;
			while(i<args.length-2){
				if(args[i].equals("-o")) override = true;
				else if(args[i].equals("-v")) verbose = true;
				else if(args[i].equals("-x")) extract = true;
				else if(args[i].equals("-c")) create = true;
				else if(args[i].equals("-p")) pack = true;
				//else if(args[i].equals("--batch")) batch = true;
				else {
					System.out.println("Invalid flag: "+args[i]);
					System.out.println("");
					help();
					return;
				}
				i++;
			}

			if((b2b(extract)+b2b(pack)+b2b(create))!=1) error("You must use one, and only one of -x, -c, or -p");
			else if(extract) com.x10hosting.nanohatakamachi.th_dnh.archiver.Decompress.decompress(args[i],args[i+1],override,verbose);
			else if(create) com.x10hosting.nanohatakamachi.th_dnh.archiver.Compress.compress(args[i],args[i+1],override,verbose,true);
			else if(pack) com.x10hosting.nanohatakamachi.th_dnh.archiver.Compress.compress(args[i],args[i+1],override,verbose,false);
			else error("Internal error");
		}
	}
	private static byte b2b(boolean b){
		return (byte)(b?1:0);
	}
	private static void error(String e){
		System.out.println(e);System.out.println("");
		help();
	}
	private static void help(){
		System.out.println("Usage: java -jar th_dnh_archiver.jar [-o] [-v] -<x|c|p> <archive> <output folder>");
		System.out.println("  -o: Prompt before overriding files.");
		System.out.println("  -x: Extract files from archive.");
		System.out.println("  -c: Compress files into archive.");
		System.out.println("  -p: Pack files into archive.");
	}
	private static void start(){
		System.out.println("th_dnh_archiver v1.0 Copyright (C) 2010 Legend_Bird");
		System.out.println("This program comes with ABSOLUTELY NO WARRANTY, is free software, and you");
		System.out.println("are welcome to redistribute it under certain conditions; see <LICENCE.txt> for");
		System.out.println("details.");
		System.out.println("");
	}    

}
